
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Report_attachmentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const report_attachments = await db.report_attachments.create(
            {
                id: data.id || undefined,
        
        content_type: data.content_type
        ||
        null
            ,
            
        uploaded_at: data.uploaded_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await report_attachments.setReport( data.report || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.report_attachments.getTableName(),
                belongsToColumn: 'file',
                belongsToId: report_attachments.id,
            },
            data.file,
            options,
        );
        

        return report_attachments;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const report_attachmentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                content_type: item.content_type
            ||
            null
            ,
            
                uploaded_at: item.uploaded_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const report_attachments = await db.report_attachments.bulkCreate(report_attachmentsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < report_attachments.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.report_attachments.getTableName(),
                    belongsToColumn: 'file',
                    belongsToId: report_attachments[i].id,
                },
                data[i].file,
                options,
            );
        }
        

        return report_attachments;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const report_attachments = await db.report_attachments.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.content_type !== undefined) updatePayload.content_type = data.content_type;
        
        
        if (data.uploaded_at !== undefined) updatePayload.uploaded_at = data.uploaded_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await report_attachments.update(updatePayload, {transaction});

        
        
        if (data.report !== undefined) {
            await report_attachments.setReport(
              
              data.report,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.report_attachments.getTableName(),
                belongsToColumn: 'file',
                belongsToId: report_attachments.id,
            },
            data.file,
            options,
        );
        

        return report_attachments;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const report_attachments = await db.report_attachments.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of report_attachments) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of report_attachments) {
                await record.destroy({transaction});
            }
        });


        return report_attachments;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const report_attachments = await db.report_attachments.findByPk(id, options);

        await report_attachments.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await report_attachments.destroy({
            transaction
        });

        return report_attachments;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const report_attachments = await db.report_attachments.findOne(
            { where },
            { transaction },
        );

        if (!report_attachments) {
            return report_attachments;
        }

        const output = report_attachments.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.report = await report_attachments.getReport({
            transaction
        });
        
        
        output.file = await report_attachments.getFile({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.reports,
        as: 'report',
        
        where: filter.report ? {
          [Op.or]: [
            { id: { [Op.in]: filter.report.split('|').map(term => Utils.uuid(term)) } },
            {
              details: {
                [Op.or]: filter.report.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'file',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.content_type) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'report_attachments',
                        'content_type',
                        filter.content_type,
                    ),
                };
            }
            

            
            

            
            if (filter.uploaded_atRange) {
                const [start, end] = filter.uploaded_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    uploaded_at: {
                    ...where.uploaded_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    uploaded_at: {
                    ...where.uploaded_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.report_attachments.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'report_attachments',
                        'content_type',
                        query,
                    ),
                ],
            };
        }

        const records = await db.report_attachments.findAll({
            attributes: [ 'id', 'content_type' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['content_type', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.content_type,
        }));
    }

    
};

